Index: /XIOS/dev/branch_yushan_merged/src/filter/store_filter.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/filter/store_filter.hpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/filter/store_filter.hpp	(revision 1205)
@@ -22,6 +22,9 @@
        * \param context the context to which the data belongs
        * \param grid the grid to which the data is attached
+       * \param detectMissingValues whether missing values should be detected
+       * \param missingValue the value to use to replace missing values
        */
-      CStoreFilter(CGarbageCollector& gc, CContext* context, CGrid* grid);
+      CStoreFilter(CGarbageCollector& gc, CContext* context, CGrid* grid,
+                   bool detectMissingValues = false, double missingValue = 0.0);
 
       /*!
@@ -75,4 +78,6 @@
       CContext* context; //!< The context to which the data belongs
       CGrid* grid; //!< The grid attached to the data the filter can accept
+      const bool detectMissingValues; //!< Whether missing values should be detected
+      const double missingValue; //!< The value to use to replace missing values
       std::map<Time, CDataPacketPtr> packets; //<! The stored packets
   }; // class CStoreFilter
Index: /XIOS/dev/branch_yushan_merged/src/filter/temporal_filter.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/filter/temporal_filter.hpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/filter/temporal_filter.hpp	(revision 1205)
@@ -48,6 +48,9 @@
 
     private:
+      // Warning the declaration order matters here, double-check the constructor before changing it
+      CArray<double, 1> tmpData; //!< The array of data used for temporary storage
       const boost::scoped_ptr<func::CFunctor> functor; //!< The functor corresponding to the temporal operation
-      CArray<double, 1> tmpData; //!< The array of data used for temporary storage
+      const bool isOnceOperation; //!< True if the operation should be computed just once
+      const bool isInstantOperation; //!< True if the operation is instant
       const CDuration samplingFreq; //!< The sampling frequency, i.e. the frequency at which the input data will be used
       const CDuration samplingOffset; //!< The sampling offset, i.e. the offset after which the input data will be used
@@ -56,6 +59,4 @@
       CDate nextOperationDate; //!< The date of the next operation
       bool isFirstOperation; //!< True before the first operation was been computed
-      const bool isOnceOperation; //!< True if the operation should be computed just once
-      const bool isInstantOperation; //!< True if the operation is instant
   }; // class CTemporalFilter
 } // namespace xios
Index: /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfield_attr.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfield_attr.cpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfield_attr.cpp	(revision 1205)
@@ -119,4 +119,27 @@
 
 
+  void cxios_set_field_check_if_active(field_Ptr field_hdl, bool check_if_active)
+  {
+    CTimer::get("XIOS").resume();
+    field_hdl->check_if_active.setValue(check_if_active);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_field_check_if_active(field_Ptr field_hdl, bool* check_if_active)
+  {
+    CTimer::get("XIOS").resume();
+    *check_if_active = field_hdl->check_if_active.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_field_check_if_active(field_Ptr field_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = field_hdl->check_if_active.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_field_compression_level(field_Ptr field_hdl, int compression_level)
   {
Index: /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfieldgroup_attr.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfieldgroup_attr.cpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfieldgroup_attr.cpp	(revision 1205)
@@ -119,4 +119,27 @@
 
 
+  void cxios_set_fieldgroup_check_if_active(fieldgroup_Ptr fieldgroup_hdl, bool check_if_active)
+  {
+    CTimer::get("XIOS").resume();
+    fieldgroup_hdl->check_if_active.setValue(check_if_active);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_fieldgroup_check_if_active(fieldgroup_Ptr fieldgroup_hdl, bool* check_if_active)
+  {
+    CTimer::get("XIOS").resume();
+    *check_if_active = fieldgroup_hdl->check_if_active.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_fieldgroup_check_if_active(fieldgroup_Ptr fieldgroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = fieldgroup_hdl->check_if_active.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_fieldgroup_compression_level(fieldgroup_Ptr fieldgroup_hdl, int compression_level)
   {
Index: /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfile_attr.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfile_attr.cpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfile_attr.cpp	(revision 1205)
@@ -90,4 +90,30 @@
 
 
+  void cxios_set_file_convention_str(file_Ptr file_hdl, const char * convention_str, int convention_str_size)
+  {
+    std::string convention_str_str;
+    if (!cstr2string(convention_str, convention_str_size, convention_str_str)) return;
+    CTimer::get("XIOS").resume();
+    file_hdl->convention_str.setValue(convention_str_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_file_convention_str(file_Ptr file_hdl, char * convention_str, int convention_str_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(file_hdl->convention_str.getInheritedValue(), convention_str, convention_str_size))
+      ERROR("void cxios_get_file_convention_str(file_Ptr file_hdl, char * convention_str, int convention_str_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_file_convention_str(file_Ptr file_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = file_hdl->convention_str.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_file_cyclic(file_Ptr file_hdl, bool cyclic)
   {
Index: /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfilegroup_attr.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfilegroup_attr.cpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icfilegroup_attr.cpp	(revision 1205)
@@ -90,4 +90,30 @@
 
 
+  void cxios_set_filegroup_convention_str(filegroup_Ptr filegroup_hdl, const char * convention_str, int convention_str_size)
+  {
+    std::string convention_str_str;
+    if (!cstr2string(convention_str, convention_str_size, convention_str_str)) return;
+    CTimer::get("XIOS").resume();
+    filegroup_hdl->convention_str.setValue(convention_str_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_filegroup_convention_str(filegroup_Ptr filegroup_hdl, char * convention_str, int convention_str_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(filegroup_hdl->convention_str.getInheritedValue(), convention_str, convention_str_size))
+      ERROR("void cxios_get_filegroup_convention_str(filegroup_Ptr filegroup_hdl, char * convention_str, int convention_str_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_filegroup_convention_str(filegroup_Ptr filegroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = filegroup_hdl->convention_str.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_filegroup_cyclic(filegroup_Ptr filegroup_hdl, bool cyclic)
   {
Index: /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icinterpolate_domain_attr.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icinterpolate_domain_attr.cpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/c_attr/icinterpolate_domain_attr.cpp	(revision 1205)
@@ -62,4 +62,27 @@
      CTimer::get("XIOS").resume();
      bool isDefined = interpolate_domain_hdl->order.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
+  void cxios_set_interpolate_domain_quantity(interpolate_domain_Ptr interpolate_domain_hdl, bool quantity)
+  {
+    CTimer::get("XIOS").resume();
+    interpolate_domain_hdl->quantity.setValue(quantity);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_interpolate_domain_quantity(interpolate_domain_Ptr interpolate_domain_hdl, bool* quantity)
+  {
+    CTimer::get("XIOS").resume();
+    *quantity = interpolate_domain_hdl->quantity.getInheritedValue();
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_interpolate_domain_quantity(interpolate_domain_Ptr interpolate_domain_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = interpolate_domain_hdl->quantity.hasInheritedValue();
      CTimer::get("XIOS").suspend();
      return isDefined;
Index: /XIOS/dev/branch_yushan_merged/src/interface/c_attr/iczoom_axis_attr.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/c_attr/iczoom_axis_attr.cpp	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/c_attr/iczoom_axis_attr.cpp	(revision 1205)
@@ -41,4 +41,29 @@
 
 
+  void cxios_set_zoom_axis_index(zoom_axis_Ptr zoom_axis_hdl, int* index, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(index, shape(extent[0]), neverDeleteData);
+    zoom_axis_hdl->index.reference(tmp.copy());
+     CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_zoom_axis_index(zoom_axis_Ptr zoom_axis_hdl, int* index, int* extent)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<int,1> tmp(index, shape(extent[0]), neverDeleteData);
+    tmp=zoom_axis_hdl->index.getInheritedValue();
+     CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_zoom_axis_index(zoom_axis_Ptr zoom_axis_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = zoom_axis_hdl->index.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_zoom_axis_n(zoom_axis_Ptr zoom_axis_hdl, int n)
   {
Index: /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/field_interface_attr.F90
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/field_interface_attr.F90	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/field_interface_attr.F90	(revision 1205)
@@ -92,4 +92,23 @@
 
 
+    SUBROUTINE cxios_set_field_check_if_active(field_hdl, check_if_active) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: field_hdl
+      LOGICAL (KIND=C_BOOL)      , VALUE :: check_if_active
+    END SUBROUTINE cxios_set_field_check_if_active
+
+    SUBROUTINE cxios_get_field_check_if_active(field_hdl, check_if_active) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: field_hdl
+      LOGICAL (KIND=C_BOOL)             :: check_if_active
+    END SUBROUTINE cxios_get_field_check_if_active
+
+    FUNCTION cxios_is_defined_field_check_if_active(field_hdl) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_field_check_if_active
+      INTEGER (kind = C_INTPTR_T), VALUE :: field_hdl
+    END FUNCTION cxios_is_defined_field_check_if_active
+
+
     SUBROUTINE cxios_set_field_compression_level(field_hdl, compression_level) BIND(C)
       USE ISO_C_BINDING
Index: /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/fieldgroup_interface_attr.F90
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/fieldgroup_interface_attr.F90	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/fieldgroup_interface_attr.F90	(revision 1205)
@@ -92,4 +92,23 @@
 
 
+    SUBROUTINE cxios_set_fieldgroup_check_if_active(fieldgroup_hdl, check_if_active) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: fieldgroup_hdl
+      LOGICAL (KIND=C_BOOL)      , VALUE :: check_if_active
+    END SUBROUTINE cxios_set_fieldgroup_check_if_active
+
+    SUBROUTINE cxios_get_fieldgroup_check_if_active(fieldgroup_hdl, check_if_active) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: fieldgroup_hdl
+      LOGICAL (KIND=C_BOOL)             :: check_if_active
+    END SUBROUTINE cxios_get_fieldgroup_check_if_active
+
+    FUNCTION cxios_is_defined_fieldgroup_check_if_active(fieldgroup_hdl) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_fieldgroup_check_if_active
+      INTEGER (kind = C_INTPTR_T), VALUE :: fieldgroup_hdl
+    END FUNCTION cxios_is_defined_fieldgroup_check_if_active
+
+
     SUBROUTINE cxios_set_fieldgroup_compression_level(fieldgroup_hdl, compression_level) BIND(C)
       USE ISO_C_BINDING
Index: /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/file_interface_attr.F90
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/file_interface_attr.F90	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/file_interface_attr.F90	(revision 1205)
@@ -69,4 +69,25 @@
 
 
+    SUBROUTINE cxios_set_file_convention_str(file_hdl, convention_str, convention_str_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: file_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: convention_str
+      INTEGER  (kind = C_INT)     , VALUE        :: convention_str_size
+    END SUBROUTINE cxios_set_file_convention_str
+
+    SUBROUTINE cxios_get_file_convention_str(file_hdl, convention_str, convention_str_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: file_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: convention_str
+      INTEGER  (kind = C_INT)     , VALUE        :: convention_str_size
+    END SUBROUTINE cxios_get_file_convention_str
+
+    FUNCTION cxios_is_defined_file_convention_str(file_hdl) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_file_convention_str
+      INTEGER (kind = C_INTPTR_T), VALUE :: file_hdl
+    END FUNCTION cxios_is_defined_file_convention_str
+
+
     SUBROUTINE cxios_set_file_cyclic(file_hdl, cyclic) BIND(C)
       USE ISO_C_BINDING
Index: /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/filegroup_interface_attr.F90
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/filegroup_interface_attr.F90	(revision 1204)
+++ /XIOS/dev/branch_yushan_merged/src/interface/fortran_attr/filegroup_interface_attr.F90	(revision 1205)
@@ -69,4 +69,25 @@
 
 
+    SUBROUTINE cxios_set_filegroup_convention_str(filegroup_hdl, convention_str, convention_str_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: convention_str
+      INTEGER  (kind = C_INT)     , VALUE        :: convention_str_size
+    END SUBROUTINE cxios_set_filegroup_convention_str
+
+    SUBROUTINE cxios_get_filegroup_convention_str(filegroup_hdl, convention_str, convention_str_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: convention_str
+      INTEGER  (kind = C_INT)     , VALUE        :: convention_str_size
+    END SUBROUTINE cxios_get_filegroup_convention_str
+
+    FUNCTION cxios_is_defined_filegroup_convention_str(filegroup_hdl) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_filegroup_convention_str
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+    END FUNCTION cxios_is_defined_filegroup_convention_str
+
+
     SUBROUTINE cxios_set_filegroup_cyclic(filegroup_hdl, cyclic) BIND(C)
       USE ISO_C_BINDING
